//TODO: Rainbow filter

#property copyright "bonten"
#property link      "bd0ppens@gmail.com"

extern double TakeProfit = 70;
extern double StopLoss = 35;
extern double TrailingStop = 10;
extern double RiskToUseWhenGTMaches = 0.03;
extern double RiskToUseWhenGTDoesntMatch = 0.01;
extern double DecreaseFactor = 2;
extern int Slippage = 3;
extern string EAComment = "chartista_v1";
extern int MagicNumber = 1828212;

int SIGNAL_BUY = 0;
int SIGNAL_SELL = 1;
int SIGNAL_NONE = 2;

double risk = 0;


int GetMASignal()
{
   double rsi = iRSI(NULL, 0, 21, PRICE_CLOSE, 0);
   double price = iOpen(Symbol(), NULL, 0);
   double trigger = iMA(NULL, 0, 6, 0, MODE_EMA, PRICE_CLOSE, 0);
   double MA1 = iMA(NULL, 0, 18, 0, MODE_EMA, PRICE_CLOSE, 0);
   double MA2 = iMA(NULL, 0, 28, 0, MODE_EMA, PRICE_CLOSE, 0);
   
   if ((price > trigger) && (MA1 > MA2) && (rsi < 60))
   {
      Print("BUY found GetMASignal");
      return (SIGNAL_BUY);
   }
   if ((price < trigger) && (MA1 < MA2) && (rsi > 40))
   {
      Print("SELL found GetMASignal");
      return (SIGNAL_SELL);
   }
   
   return (SIGNAL_NONE);
}

int GetSilverTrendSignal(int period)
{
   double signal = 0;
   
   for (int shift = 0; shift < 255; shift++)
   {
      signal = (iCustom(NULL, period, "SilverTrend_Signal", 9, 350, 0, shift));
      if (signal != 0) 
      {
         Print("BUY found at ", shift, " bars");
         return (SIGNAL_BUY);
      }
      signal = (iCustom(NULL, period, "SilverTrend_Signal", 9, 350, 1, shift));
      if (signal != 0) 
      {
         Print("SELL found at ", shift, " bars");
         return (SIGNAL_SELL);
      }
   }
   return (SIGNAL_NONE);
}

int GetRainbowSignal()
{
   //TODO
}

void init()
{
   return (0);
}

void deinit() 
{
   return (0);
}

int start()
{
   if (Bars < 100)
   {
      Print("Bars less than 100");
      return(0);
   }
   if (StopLoss < 8)
   {
      Print("StopLoss less than 10");
      return(0);
   }
 
   if (!ExistPositions())
   {  
      if (GetMASignal() == SIGNAL_BUY)
      {
         if (GetSilverTrendSignal(PERIOD_H4) == SIGNAL_BUY)
         {
            OrderSend(Symbol(), OP_BUY, LotsOptimized(DetermineRisk(SIGNAL_BUY)), Ask, Slippage, Ask - StopLoss * Point, Ask + TakeProfit * Point, EAComment, MagicNumber, 0, Green);
            return(0);
         }
      }
      else if (GetMASignal() == SIGNAL_SELL)
      {
         if (GetSilverTrendSignal(PERIOD_H4) == SIGNAL_SELL)           
         {
            OrderSend(Symbol(), OP_SELL, LotsOptimized(DetermineRisk(SIGNAL_SELL)), Bid, Slippage, Bid + StopLoss * Point, Bid - TakeProfit * Point, EAComment, MagicNumber, 0, Red);
            return(0);
         }
      }
   }
   
   TrailingPositions(TrailingStop);
   return (0);
}

bool ExistPositions() 
{
	for (int i = 0; i < OrdersTotal(); i++) 
	{
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
		{
			if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
				return (true);
			}
		} 
	} 
	return(false);
}

void TrailingPositions(int trailingStop) 
{ 
   for (int i = 0; i < OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         { 
            if (OrderType() == OP_BUY) 
            { 
               if (Bid - OrderOpenPrice() > trailingStop * Point) 
               { 
                  if (OrderStopLoss() < Bid - trailingStop * Point) 
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - trailingStop * Point, OrderTakeProfit(), 0, CLR_NONE);
               } 
            } 
            else if (OrderType() == OP_SELL) 
            { 
               if (OrderOpenPrice() - Ask > trailingStop * Point) 
               { 
                  if (OrderStopLoss() > Ask + trailingStop * Point || OrderStopLoss() == 0)  
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + trailingStop * Point, OrderTakeProfit(), 0, CLR_NONE);
               } 
            } 
         } 
      } 
   } 
} 

double DetermineRisk(int signal)
{
   double risk;
   
   if (GetSilverTrendSignal(PERIOD_D1) == signal)
      risk = RiskToUseWhenGTMaches;
   else
      risk = RiskToUseWhenGTDoesntMatch;
   return (risk);
}

double LotsOptimized(double risk)
{
   int orders = HistoryTotal();     
   int losses = 0;             
  
   double lot = NormalizeDouble(AccountFreeMargin() * risk / 500, 1);
   if (DecreaseFactor > 0)
   {
      for (int i = orders - 1; i >= 0; i--)
      {
         if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == false) 
         { 
            Print("Error in history!"); 
            break; 
         }
    
         if (OrderSymbol() != Symbol() || OrderType() > OP_SELL) 
            continue;
         
         if (OrderProfit() > 0) 
            break;
        
         if (OrderProfit() < 0) 
            losses++;
      }
      if (losses > 1) 
         lot = NormalizeDouble(lot - lot * losses / DecreaseFactor, 1);
   }
   
   if (lot < 0.1) 
      lot = 0.1;
      
   Print("LOT: ", lot);
   return(lot);
}    
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+